// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from foros_msgs:srv/AppendEntries.idl
// generated code does not contain a copyright notice

#ifndef FOROS_MSGS__SRV__DETAIL__APPEND_ENTRIES__TRAITS_HPP_
#define FOROS_MSGS__SRV__DETAIL__APPEND_ENTRIES__TRAITS_HPP_

#include "foros_msgs/srv/detail/append_entries__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

namespace rosidl_generator_traits
{

inline void to_yaml(
  const foros_msgs::srv::AppendEntries_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: term
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "term: ";
    value_to_yaml(msg.term, out);
    out << "\n";
  }

  // member: leader_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "leader_id: ";
    value_to_yaml(msg.leader_id, out);
    out << "\n";
  }

  // member: prev_log_index
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "prev_log_index: ";
    value_to_yaml(msg.prev_log_index, out);
    out << "\n";
  }

  // member: prev_log_term
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "prev_log_term: ";
    value_to_yaml(msg.prev_log_term, out);
    out << "\n";
  }

  // member: entries
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.entries.size() == 0) {
      out << "entries: []\n";
    } else {
      out << "entries:\n";
      for (auto item : msg.entries) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        character_value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: leader_commit
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "leader_commit: ";
    value_to_yaml(msg.leader_commit, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const foros_msgs::srv::AppendEntries_Request & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<foros_msgs::srv::AppendEntries_Request>()
{
  return "foros_msgs::srv::AppendEntries_Request";
}

template<>
inline const char * name<foros_msgs::srv::AppendEntries_Request>()
{
  return "foros_msgs/srv/AppendEntries_Request";
}

template<>
struct has_fixed_size<foros_msgs::srv::AppendEntries_Request>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<foros_msgs::srv::AppendEntries_Request>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<foros_msgs::srv::AppendEntries_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

inline void to_yaml(
  const foros_msgs::srv::AppendEntries_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: term
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "term: ";
    value_to_yaml(msg.term, out);
    out << "\n";
  }

  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    value_to_yaml(msg.success, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const foros_msgs::srv::AppendEntries_Response & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<foros_msgs::srv::AppendEntries_Response>()
{
  return "foros_msgs::srv::AppendEntries_Response";
}

template<>
inline const char * name<foros_msgs::srv::AppendEntries_Response>()
{
  return "foros_msgs/srv/AppendEntries_Response";
}

template<>
struct has_fixed_size<foros_msgs::srv::AppendEntries_Response>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<foros_msgs::srv::AppendEntries_Response>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<foros_msgs::srv::AppendEntries_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<foros_msgs::srv::AppendEntries>()
{
  return "foros_msgs::srv::AppendEntries";
}

template<>
inline const char * name<foros_msgs::srv::AppendEntries>()
{
  return "foros_msgs/srv/AppendEntries";
}

template<>
struct has_fixed_size<foros_msgs::srv::AppendEntries>
  : std::integral_constant<
    bool,
    has_fixed_size<foros_msgs::srv::AppendEntries_Request>::value &&
    has_fixed_size<foros_msgs::srv::AppendEntries_Response>::value
  >
{
};

template<>
struct has_bounded_size<foros_msgs::srv::AppendEntries>
  : std::integral_constant<
    bool,
    has_bounded_size<foros_msgs::srv::AppendEntries_Request>::value &&
    has_bounded_size<foros_msgs::srv::AppendEntries_Response>::value
  >
{
};

template<>
struct is_service<foros_msgs::srv::AppendEntries>
  : std::true_type
{
};

template<>
struct is_service_request<foros_msgs::srv::AppendEntries_Request>
  : std::true_type
{
};

template<>
struct is_service_response<foros_msgs::srv::AppendEntries_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // FOROS_MSGS__SRV__DETAIL__APPEND_ENTRIES__TRAITS_HPP_
